//THIS IS A MASH OF TEMPERATURE, SLEEP, AND PACHUBE FUNCTIONS FROM: list sites

//TESTED WITH ARDUINO 18
//make sure to open a port to your arduino on your firewall

//ALSO ADDED SUBNET MASK

/* ==============================
 * This code, which assumes you're using the official Arduino Ethernet shield,
 * updates a Pachube feed with your analog-in values and grabs values from a Pachube
 * feed - basically it enables you to have both "local" and "remote" sensors.
 * 
 * Tested with Arduino 14
 *
 * Pachube is www.pachube.com - connect, tag and share real time sensor data
 * code by usman (www.haque.co.uk), may 2009
 * copy, distribute, whatever, as you like.
 *
 * v1.1 - added User-Agent & fixed HTTP parser for new Pachube headers
 * and check millis() for when it wraps around
 *
 * =============================== */

//TEMPERATURE & SLEEP STUFF

#include <OneWire.h>
#include <DallasTemperature.h>
#include <avr/sleep.h>

// Data wire is plugged into port 3 on the Arduino
#define ONE_WIRE_BUS 4
#define TEMPERATURE_PRECISION 9

// Setup a oneWire instance to communicate with any OneWire devices (not just Maxim/Dallas temperature ICs)
OneWire oneWire(ONE_WIRE_BUS);

// Pass our oneWire reference to Dallas Temperature. 
DallasTemperature sensors(&oneWire);

// arrays to hold device addresses
DeviceAddress zeroThermometer, oneThermometer, twoThermometer, threeThermometer;


int wakePin = 2;                //pin used for wakeup 

float temp0 = 0;              //stores temperature from temp sensors
float temp1 = 0;
float temp2 = 0;
float temp3 = 0;

int intTemp0 = 0;              //for integer conversion of temps.  sprintf won't accept floats
int intTemp1 = 0;
int intTemp2 = 0;
int intTemp3 = 0;

 // ===============================
//PACHUBE CODE

#include <Ethernet.h>
#include <string.h>

#undef int() // needed by arduino 0011 to allow use of stdio
#include <stdio.h> // for function sprintf

#define SHARE_FEED_ID              5441     // this is your Pachube feed ID that you want to share to
#define REMOTE_FEED_ID             5441      // this is the ID of the remote Pachube feed that you want to connect to
#define REMOTE_FEED_DATASTREAMS    4        // make sure that remoteSensor array is big enough to fit all the remote data streams
#define UPDATE_INTERVAL            10000    // if the connection is good wait 10 seconds before updating again - should not be less than 5
#define RESET_INTERVAL             10000    // if connection fails/resets wait 10 seconds before trying again - should not be less than 5

#define PACHUBE_API_KEY            "PACHUBE API KEY HERE" // fill in your API key 

byte mac[] = { 0xCC, 0xAC, 0xBE, 0xEF, 0xFE, 0x91 }; // make sure this is unique on your network
byte ip[] = { 192, 168, 1, 177  };                  // no DHCP so we set our own IP address
byte remoteServer[] = { 209,40,205,190 };            // pachube.com
byte subnet[] = { 255, 255, 255, 0 };              //THE DEFAULT SUBNET MASK IS 255.255.0.0, WHICH WAS FUCKING UP MY PROGRAM- Mathew
byte gateway[] = {192, 168, 1, 1};                      // added at twinkel's suggestion

float remoteSensor[REMOTE_FEED_DATASTREAMS];        // we know that feed 256 has floats - this might need changing for feeds without floats


void wakeUpNow()              //here is the interupt is handled after wakeup
{
}


void setup()
{
  Serial.begin(57600); 
 

 
  setupEthernet(); 
 
  delay (1000);             //added according to    twinkel's suggestion in notes on Arduino ethernet MATHEW
  
 
    pinMode (wakePin, INPUT);         //set wakePin

  attachInterrupt(0, wakeUpNow, LOW);  //use interrupt 0 (pin2) and run function wakeUpNow when pin 2 gets LOW

  
  // start serial port
  Serial.begin(9600);

  // Start up the library
  sensors.begin();

  // locate devices on the bus
  Serial.print("Locating devices...");
  Serial.print("Found ");
  Serial.print(sensors.getDeviceCount(), DEC);
  Serial.println(" devices.");

  // report parasite power requirements
  Serial.print("Parasite power is: "); 
  if (sensors.isParasitePowerMode()) Serial.println("ON");
  else Serial.println("OFF");


  //assign address manually.  the addresses below will beed to be changed
  // to valid device addresses on your bus.  device address can be retrieved
  // by using either oneWire.search(deviceAddress) or individually via
  // sensors.getAddress(deviceAddress, index)
  //zeroThermometer = { 0x28, 0x1D, 0x39, 0x31, 0x2, 0x0, 0x0, 0xF0 };
  //oneThermometer   = { 0x28, 0x3F, 0x1C, 0x31, 0x2, 0x0, 0x0, 0x2 };

  // search for devices on the bus and assign based on an index.  ideally,
  // you would do this to initially discover addresses on the bus and then 
  // use those addresses and manually assign them (see above) once you know 
  // the devices on your bus (and assuming they don't change).
  // 
  // method 1: by index
  // if (!sensors.getAddress(zeroThermometer, 0)) Serial.println("Unable to find address for Device 0"); 
  // if (!sensors.getAddress(oneThermometer, 1)) Serial.println("Unable to find address for Device 1"); 
  // if (!sensors.getAddress(twoThermometer, 2)) Serial.println("Unable to find address for Device 2"); 
  // method 2: search()
  // search() looks for the next device. Returns 1 if a new address has been
  // returned. A zero might mean that the bus is shorted, there are no devices, 
  // or you have already retrieved all of them.  It might be a good idea to 
  // check the CRC to make sure you didn't get garbage.  The order is 
  // deterministic. You will always get the same devices in the same order
  //
  // Must be called before search()
  //oneWire.reset_search();
  
  //I MAY HAVE TO ASSIGN MANUALLY... NOT SURE THIS METHOD GRABS IN THE RIGHT ORDER
  // assigns the first address found to zeroThermometer
 if (!oneWire.search(zeroThermometer)) Serial.println("Unable to find address for zeroThermometer");
  // assigns the seconds address found to oneThermometer
 if (!oneWire.search(oneThermometer)) Serial.println("Unable to find address for oneThermometer");
 if (!oneWire.search(twoThermometer)) Serial.println("Unable to find address for twoThermometer");
 if (!oneWire.search(threeThermometer)) Serial.println("Unable to find address for threeThermometer");
  // show the addresses we found on the bus

  
  // set the resolution to 9 bit
  sensors.setResolution(zeroThermometer, 9);
  sensors.setResolution(oneThermometer, 9);
  sensors.setResolution(twoThermometer, 9);
  sensors.setResolution(threeThermometer, 9);
}

// function to print the temperature for a device
void printTemperature(DeviceAddress deviceAddress)
{
  float tempC = sensors.getTempC(deviceAddress);
  Serial.print("Temp C: ");
  Serial.print(tempC);
  Serial.print(" Temp F: ");
  Serial.print(DallasTemperature::toFahrenheit(tempC));
}

void sleepNow()
{
  set_sleep_mode(SLEEP_MODE_PWR_DOWN);
  sleep_enable();
  attachInterrupt(0, wakeUpNow, LOW);
  sleep_mode();        //go to sleep
  sleep_disable();    //wake up
  detachInterrupt(0);
}


void loop()
{

  // call 'pachube_in_out' at the beginning of the loop, handles timing, requesting
  // and reading. use serial monitor to view debug messages


  Serial.print("Requesting temperatures...");
  sensors.requestTemperatures();
  
//printTemperature(zeroThermometer);
//printTemperature(oneThermometer);
//printTemperature(twoThermometer); 

temp0 = sensors.getTempC(zeroThermometer);
temp1 = sensors.getTempC(oneThermometer); 
temp2 = sensors.getTempC(twoThermometer); 
temp3 = sensors.getTempC(threeThermometer); 
//temp0,1,2 all send to pachube over in pachube_functions in the sprintf 


intTemp0 = (int) temp0;
intTemp1 = (int) temp1;
intTemp2 = (int) temp2;
intTemp3 = (int) temp3;

Serial.print(intTemp0);
Serial.print(intTemp1);
Serial.print(intTemp2);
Serial.print(intTemp3); 
 
  Serial.println("DONE");
  
  delay (1000);

  pachube_in_out();

  // then put your code here, you can access remote sensor values
  // by using the remoteSensor float array, e.g.: 

  // call sensors.requestTemperatures() to issue a global temperature 
  // request to all devices on the bus

  delay (1000);
  
// sleepNow();                  //sleeps after reporting temperature


}

